//---------------------------------------------------------------------------
#ifndef ObjDetailsH
#define ObjDetailsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "cspin.h"
#include <ComCtrls.hpp>
#include "OpenGl.h"
#include "OpenGl.h"
#include "OpenGl.h"
#include "OpenGl.h"
#include "Pos3D.h"
//---------------------------------------------------------------------------
class TObjectDetails : public TForm
{
__published:	// IDE-managed Components
    TPageControl *Details;
    TTabSheet *TabSheet1;
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TLabel *Label4;
    TLabel *Label5;
    TPos3D *Position;
    TEdit *Name;
    TPos3D *RotationVector;
    TPos3D *Scale;
    TAngleEdit *RotationAngle;
    TLabel *FullName;
    TTabSheet *SpherePage;
    TLabel *Label6;
    TLabel *Label7;
    TCSpinEdit *SphereSlices;
    TCSpinEdit *SphereStacks;
    TTabSheet *CylinderPage;
    TTabSheet *DiskPage;
    TLabel *Label8;
    TLabel *Label9;
    TCSpinEdit *CylinderSlices;
    TCSpinEdit *CylinderStacks;
    TLabel *Label10;
    TLabel *Label11;
    TCSpinEdit *DiskSlices;
    TCSpinEdit *DiskLoops;
    TFloatEdit *CylinderParams;
    TFloatEdit *DiskParams;
    TTabSheet *QuadPage;
    TComboBox *Shape;
    TLabel *Label12;
    TCSpinEdit *NPoints;
    TLabel *Label13;
    TPanel *Panel1;
    TCSpinEdit *CurrPoint;
    TLabel *Label14;
    TPos3D *Vertex;
    TLabel *Label15;
    TLabel *Label16;
    TPos3D *Normal;
    void __fastcall FormHide(TObject *Sender);
    
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall NameChange(TObject *Sender);
    void __fastcall PositionChange(TObject *Sender);
    void __fastcall RotationVectorChange(TObject *Sender);
    void __fastcall ScaleChange(TObject *Sender);

    void __fastcall RotationAngleChange(TObject *Sender);
    void __fastcall SphereParamsChange(TObject *Sender);
    void __fastcall CylinderParamsChange(TObject *Sender);
    void __fastcall DiskParamsChange(TObject *Sender);
    void __fastcall CurrPointChange(TObject *Sender);
    void __fastcall VertexChange(TObject *Sender);
    void __fastcall ShapeChange(TObject *Sender);
    void __fastcall NPointsChange(TObject *Sender);
    void __fastcall NormalChange(TObject *Sender);
private:	// User declarations
    bool  noclick;
public:		// User declarations
    void __fastcall RefreshQuadVertex(TObject *Sender);
    void __fastcall UpdateQuadVertex(TObject *Sender);

    void NoClick(bool b) {noclick = b;}
    __fastcall TObjectDetails(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TObjectDetails *ObjectDetails;
//---------------------------------------------------------------------------
#endif
