//---------------------------------------------------------------------------
#ifndef OglTestFormH
#define OglTestFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "OpenGl.h"
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>
#include "OpenGl.h"
#include "OpenGl.h"
#include "OpenGl.h"
#include "OpenGl.h"
#include "Pos3D.h"
//---------------------------------------------------------------------------

class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TPanel *Panel1;
    TPanel *Panel2;
    TPanel *Panel3;
    TLabel *Label1;
    TEdit *Fps;
    TOpenGl *gl;
    TPageControl *Props;
    TTabSheet *Projection;
    TScrollBar *ProjWidth;
    TLabel *Label2;
    TScrollBar *ProjHeight;
    TScrollBar *ProjNear;
    TScrollBar *ProjFar;
    TLabel *Label3;
    TLabel *Label4;
    TLabel *Label5;
    TCheckBox *Orthogonal;
    TTabSheet *Lights;
    TComboBox *Luci;
    TCheckBox *LuceEnabled;
    TPageControl *PageControl2;
    TTabSheet *LucePos;
    TTabSheet *Ambient;
    TLabel *Label18;
    TScrollBar *ProjYAngle;
    TTabSheet *bm;
    TImage *Image1;
    TButton *Button1;
    TButton *Button2;
    TOpenDialog *OpenDialog1;
    TLabel *ImageH;
    TLabel *ImageW;
    TComboBox *BitmapN;
    TPos3D *LucePosition;
    TPos3D *EyePosition;
    TPos3D *EyeTarget;
    TPos3D *EyeUp;
    TLabel *Label6;
    TLabel *Label7;
    TLabel *Label8;
    TTabSheet *Objects;
    TTreeView *ObjectsTree;
    TSpeedButton *ViewDetails;
    TSpeedButton *AddCube;
    TColorEdit *LuceAmbient;
    TButton *Button3;
    TLabel *Label10;
    TLabel *Label11;
    TLabel *Label12;
    TColorEdit *LuceDiffuse;
    TColorEdit *LuceSpecular;
    TSpeedButton *SpeedButton1;
    TSpeedButton *SpeedButton2;
    TCheckBox *AnimateProjection;
    TSpeedButton *SpeedButton3;
    TSpeedButton *SpeedButton4;
    TSpeedButton *SpeedButton5;
    TSpeedButton *SpeedButton6;
    TSaveDialog *SaveDialog1;
    TOpenDialog *OpenDialog2;
    TSpeedButton *SpeedButton7;
    TPopupMenu *PopupMenu1;
    TMenuItem *Copy1;
    TMenuItem *Paste1;
    TMenuItem *Clear1;
    TSpeedButton *SpeedButton8;
    TSpeedButton *Animation;
    TSpeedButton *SpeedButton9;
    void __fastcall AnimationClick(TObject *Sender);
    void __fastcall glFrame(TObject *Sender);
    void __fastcall ProjWidthChange(TObject *Sender);
    void __fastcall ProjHeightChange(TObject *Sender);
    void __fastcall ProjNearChange(TObject *Sender);
    void __fastcall ProjFarChange(TObject *Sender);
    void __fastcall OrthogonalClick(TObject *Sender);
    void __fastcall glInitRC(TObject *Sender);
    void __fastcall CubeSideChange(TObject *Sender);
    void __fastcall CubeXChange(TObject *Sender);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall LuciChange(TObject *Sender);
    void __fastcall LuceEnabledClick(TObject *Sender);
    void __fastcall ProjYAngleChange(TObject *Sender);
    void __fastcall SphereRadiusChange(TObject *Sender);
    void __fastcall Button2Click(TObject *Sender);
    void __fastcall BitmapNChange(TObject *Sender);
    
    
    void __fastcall LucePositionChange(TObject *Sender);
    void __fastcall CubePositionChange(TObject *Sender);
    void __fastcall SpherePositionChange(TObject *Sender);
    void __fastcall EyePositionChange(TObject *Sender);
    void __fastcall EyeTargetChange(TObject *Sender);
    void __fastcall EyeUpChange(TObject *Sender);
    void __fastcall ViewDetailsClick(TObject *Sender);
    void __fastcall ObjectsTreeChange(TObject *Sender, TTreeNode *Node);
    void __fastcall AddCubeClick(TObject *Sender);
    void __fastcall glListChanged(TObject *Sender);
    void __fastcall Button3Click(TObject *Sender);
    void __fastcall LuceAmbientChange(TObject *Sender);
    void __fastcall LuceDiffuseChange(TObject *Sender);
    void __fastcall LuceSpecularChange(TObject *Sender);
    void __fastcall SpeedButton1Click(TObject *Sender);
    void __fastcall SpeedButton2Click(TObject *Sender);

    
    void __fastcall glSetProjection(TObject *Sender);
    void __fastcall SpeedButton3Click(TObject *Sender);
    void __fastcall SpeedButton4Click(TObject *Sender);
    void __fastcall SpeedButton6Click(TObject *Sender);
    void __fastcall SpeedButton5Click(TObject *Sender);

    void __fastcall SpeedButton7Click(TObject *Sender);
    void __fastcall Copy1Click(TObject *Sender);
    void __fastcall Paste1Click(TObject *Sender);
    void __fastcall Clear1Click(TObject *Sender);
    void __fastcall PopupMenu1Popup(TObject *Sender);
    void __fastcall SpeedButton8Click(TObject *Sender);
    void __fastcall SpeedButton9Click(TObject *Sender);
private:	// User declarations
    TTreeNode* currSel;
    float Angle;
    float ViewAnimationAngle;
    void __fastcall SetLuci();
    void __fastcall UpdateLuce();
    GLUquadricObj *quadric;
    void __fastcall defineCube();
    void __fastcall defineSphere();
    TTreeNode * __fastcall AddObject(TTreeNode*Node, TPart * part, bool child=false);
    void __fastcall Select(TTreeNode* Node);
    TPart * FClipboard;
    void __fastcall SetClipboard(TPart * value);
    __property TPart * Clipboard = {read=FClipboard, write=SetClipboard};
public:		// User declarations
    void __fastcall UpdateTree();
    void __fastcall FillGroup(TTreeNode * pN, TPart * pP);
    __fastcall TForm1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
